COMMENT !
Seccion 39
lnformacion de refereneia
Temas tratados:
Hardware
El +2A est dise~ado en torno al microprocesador Z80, el cual funciona a una velocid~l
de 3.5469 MHz (unos tres millones y medio de ciclos por segundo).
La memoria del +2A est dividida en 64K de ROM y 12&K de RAM y distribuida en p~gl~
nas de 16K. A las cuatro p~ginas de ROM (0-3) se accede a trav s de los 16K inferior
(direcciones 0000h a 3FFFh) del mapa de la memoria. Las ocho p~ginas de RAM (9-7~
son accesibles a traves de los 16K superiores del mapa (direcciones C000h a FFFFh). L~,
p~gina 5 de la RAM tambien puede ser encajada en el margen de 4000h a 7FFFh, y Il
pAgina 2 en el comprendido entre 8000h ~ BFFFh. Ademas, hay varias formas de ocupa'
los 64K con p ginas de RAM; las combinaciones posibles han sido descritas en la Secci~~
24, apartado 'Gesti~n de la memoria'.
Fisicamente hablando, las ROM se encuentran n dos dispositivos de 32K cada uno ( imi~
lares al 27256) ~ue el sistema trata como si fuesen dos circuitos de 16K, La RAM cst~
compuesta por dieciseis circuitos de 64K ~~ 4 bits (41464), algunos de l s ~uales (bano~ i
RAM4 RAM7) est~n compartidos entre los circuitos que producen la i agen de pantal~
y el Z80A. Los otros circuitos (bancos RAMO a RAM3), asi como la~ROM, son de ~~
exclusivo del Z80A.
El eistema de compartici~n de RAM (cntrc los circuitos de video y el p oce ador) funcio~,'
del siguiente modo:
- Cada cuadro de TV consta de 311 lineas.
- De ellas, solo hay conflicto en 192.
- Cada linea de TV dura 228 estados T.
- De estos, s~1o hay conflicto en 128 estados T.
- Durante estos 128 estados T, al procesador solo se le permite usar 1 de cada ; l~
otros 7 est~n dedicados al controlador de video.
El e cto global es una reducci~n de la frecuencia de 4 a 2.66 MHz.
La matriz 16gica no comprometida (ULA, Uncommi~ted Logic Array) controla la mayor
parte de las operaciones de E/S: teclado, interfaz del magnet~fono, pantalla y partc ~
interfaz de la impresora. Convierte los bvtes que se encuentran en la memoria en form~:
y colores para la pantalla ~ permite a~ ZSOA explorar el teclado y leer y escribir,los dat~
en la cinta.
308
Capitulo 8. Guia de programaci~n en +3 BASIC
I
El sonido en tres canales es producido por el AY-3-8912, un cir~uito de sonido muy popu-
lar; este dispositivo controla tambi n las puertas RS232/MIDI y AUX.
Las dos Puertas serie so1o pueden ser controladas por programa. El +2A no incluye soft-
ware para el ~ontrol de la puerta AUX, el cual deberi ser ~estionado por e~ pr~~rama de
usuario. En cambio, la puerta RS23~/MIDI es controlada Plenamentc por +3 BASIC.
La manera en ue ~rabaja el AY-3-8912 es bastante ~ompleja; se recomienda a quienes
~ sientan tentados a experimentar que consulten la ho~a de datos del AY-3-8912. No obs-
tante, la siguiente informaci~n deberia ser suficiente para empezar.
El circuito de sonido contiene dieciseis registros; para seleccionarlos, primero se escribe
el numero de registro en la puerta de escritura de direcciones, FFFDh (65533), y despues
lee el valor del registro (en la misma direccion) o se escribe en la direccion de escritura
de registros de datos, BFFDh (49149). Una vez seleccionado un registro, se puede realizar
cualquier numero de operaciones de lectura o escritura de datos. S~1o habr~ que volver
escribir en la puerta de escritura de direcciones cuando se necesite seleccio~ar otro registro.
La frecuencia de reloj basica de este circuito es 1.7734 MHz (con precisi~n del 0.01~~o).
Los registros hacen lo siguiente:
RO  Ajuste fino del tono, canal A
R1  Ajuste aproximado del tono, canal A-
R2  Ajuste fino del tono, canal B
R3  Ajuste aproximado del tono, canal B
R4  Ajuste fino del tono, canal C
R5  Ajuste aproximado del tono, canal C

El tono de cada canal es un valor de 12 bits que se forma combinando los bits D3-DO
del registro de ajuste aproximado y los bits D7-DO del registro de ajuste fino. La uni-
dad b~sica del tono es la frecuencia de reloj ~ividida por 16 (es decir, 110.83 KHz).
Como el contador es de 12 bits, se puede g ~erar frecuencias de 27 Hz a 110 KHz.
R6  Control del generador de ruido, D4-DO
El periodo del generador de ruido se toma contando los cinco bits inferiores del regis-
tro de ruido cada periodo del reloj de sonido dividido por 16.
R7  Control del mezclador y de E/S
D7 No utilizado
D6 1=puerta de entrada, 0=puerta de salida
D5 Ruido en el canal C
D4 Ruido en el canal B
D3 Ruido en el canal A
D2 Tono en el canal C
D1 Tono en el canal B
DO Tono en el canal A
Seccion 30. Informaci~n de referencia
309
Este registro controla la mezcla de ruido y tono para cada canal y la direc i~n
puerta de E/S de o~ho bits. Un cero en un bit de mezcla indica que la funci~n
a~tivada.
R8  Control de amplitud del ca~al A
R9  Control de amplitud del canal B
RA  Control de amplitud del canal C
D4
l=utilizar generador de envolvente
O=utilizar el valor de D3-DO como amplitud
D3-DO Amplitud
Estos tres registros controlan la amplitud de cada canal y si esta debe ser modul~h
o no por los registros de envolvente.
RB  Ajuste aproximado del periodo de envolvente
RC  Ajuste fino del periodo de envolvente
Los valores de ocho bits de RB y RC se combinan para producir un numero de 1~
bits que se cuenta en unidades de 256 por el periodo del relo~ de sonido. La~ frecuea-
cias de envolvente Pueden estar entre 0.1 Hz 6 KHz.
RD  Control de envolventes
D3 Continua
D2 Ataque
Dl Alternada
DO Sostenida
El diagrama de las formas de envolvente (Seccion 19 de este capitulo) da una ilustraci~n
gr
fica de los posibles estados de este registro.
Si est~ conectada la unidad de disquete externa, su control lo realiza el circuito controla-
dor ~PD765A del interfaz externo. Tal como explicamos en la Secci~n 23, el registro dc
datos de este di~positivn est en la direcci~n 3FFDh (16381); el re~istro de estado se en-
cuentra en 2FFDh (12285). Est~ dispositivo es muy complejo, por lo ue no se debe expe-
. rimenta~ con l si no se conoce perfectamente su funcionamiento (consultese la ho a de
datos del fabricante).
La puerta de impresora paralelo (Centronics) es basicamente un 'latch' de 8 bits (74273)
cuya direcci~n es OFFDh (4093). La se~al STROBE para la impresora es generada Por la
ULA, Y est~ accesible en el bit 4 dc la direc~.i~n 1FFDh (8189). El estado de la senal BUSY
procedente de la impresora puede ser leido en el bit 0 de la direccion OFFDh (4093).
310
Capitulo 8. Guia de programacion en +3 BASIC
!

PUBLIC in_p65533,out_p65533,out_p49149

volumes	db 0FFh,03Fh,03Fh,03Fh,02Ch,026h,022h,01Dh
			db 016h,012h,0Ch,0Ah,07h,05h,02h,00

valor_2345678	dd		2345678

ay_Reg 			db		?  ;
ay_Val  			db		?  ;
ay_Tono        dw		?  ;
ay_temp			db		?  ;Variables temporales

refrescar_chip_bx dw ? ;Temporal
refrescar_chip_cx dw ? ;Temporal
refrescar_chip_dx dw ? ;Temporal


in_p65533:


					test	bits_estado4,00000010b
					jz		in_p65533_si

					mov	al,255
					ret

in_p65533_si:

					mov	bx,offset ay_3_8912_registros
					mov	al,puerto_65533
					and	al,00001111b
					xlat
					ret

out_p65533:

					test	bits_estado4,00000010b
					jnz	out_p65533_fin

					mov	puerto_65533,bl
out_p65533_fin:

					ret

out_p49149:
					;Mirar si existe el chip AY
					test	bits_estado4,00000010b
					jnz   out_p49149_no

					;Existe el chip AY

					mov	puerto_49149,bl

					mov	cl,bl
					mov	bx,offset ay_3_8912_registros
					mov	al,puerto_65533
					and	al,00001111b
					xor	ah,ah
					add	bx,ax
					mov   byte ptr [bx],cl


					test	bits_estado4,00010000b  ;Mirar salida a Sblaster
					jnz  	out_p49149_no
					cmp	soundblaster_presente,1 ;Mirar que exista SBlaster
					jz		out_p49149_sigue

out_p49149_no:

					ret

out_p49149_sigue:

					or		al,al
					jz		out_p49149_01
					cmp	al,1
					jz		out_p49149_01

					cmp	al,2
					jz		out_p49149_23
					cmp	al,3
					jz		out_p49149_23

					cmp	al,4
					jz		out_p49149_45
					cmp	al,5
					jz		out_p49149_45

					cmp	al,6
					jz		out_p49149_7  ;6 igual a 7
					cmp	al,7
					jz		out_p49149_7
					cmp	al,8
					jz		out_p49149_8
					cmp	al,9
					jz		out_p49149_9
					cmp	al,10
					jz		out_p49149_10


					ret

out_p49149_01:
					xor	al,al
					jmp	ay_set_tone

out_p49149_23:
					mov	al,1
					jmp	ay_set_tone

out_p49149_45:
					mov	al,2
					jmp	ay_set_tone


out_p49149_7:

					mov	al,0
					call	ay_set_vol
					mov	al,1
					call	ay_set_vol
					mov	al,2
					jmp	ay_set_vol

out_p49149_8:
					xor	al,al
					jmp	ay_set_vol
out_p49149_9:
					mov	al,1
					jmp	ay_set_vol
out_p49149_10:
					mov	al,2
					jmp	ay_set_vol

ay_set_vol:
;Entrada: AL=Canal(0=A,1=B,2=C)
					mov	ay_Reg,al

					mov	bx,offset puerto_canal_a
					xor	ah,ah
					shl	ax,1
					add	bx,ax
					mov	ax,word ptr [bx]
					mov	adlib_address,ax

					mov	bx,offset ay_3_8912_registros
					mov   al,ay_Reg
					add	al,8
					xlat
					test	al,16
					jz	   ay_set_vol_noenv
					mov	al,12

ay_set_vol_noenv:

					and	al,15
					mov	ay_Val,al
					mov	al,byte ptr ay_3_8912_registros+7
					mov	ah,1
					mov	cl,ay_Reg
					or		cl,cl
					jz    ay_set_vol_noenv_cero
					shl	ah,cl
ay_set_vol_noenv_cero:
					and	al,ah
					jz    ay_set_vol0
					mov	al,byte ptr volumes
					jmp	short ay_set_vol_cont

ay_set_vol0:
					mov   bx,offset volumes
					mov	al,ay_Val
					xlat

ay_set_vol_cont:
					mov	ah,43h
					add	ah,ay_Reg
					call	write_adlib

					mov	al,byte ptr ay_3_8912_registros+7
					and	al,38h
					cmp	al,38h
					jnz   ay_set_vol_no0
					;Ruido en los 3 canales
					mov	al,byte ptr volumes
					jmp	short ay_set_vol_cont2

ay_set_vol_no0:
					mov	bx,offset volumes
					mov	al,ay_Val
					xlat

ay_set_vol_cont2:

					mov	adlib_address,CANAL_CEN
					mov	ah,54h
					jmp	write_adlib


ay_set_tone:
;Entrada: AL=Canal
					mov	ay_Reg,al
					xor	ah,ah
					add	al,al

					mov	bx,offset puerto_canal_a
					add	bx,ax
					mov   cx,word ptr [bx]
					mov	adlib_address,cx

					mov	bx,offset ay_3_8912_registros
					add	bx,ax
					mov	bx,word ptr [bx]
					and	bx,4095
					cmp	bx,36
					jc	   ay_set_tone2

					mov	ax,word ptr valor_2345678
					mov	dx,word ptr valor_2345678+2
					div	bx
					jmp	short ay_set_tone3

ay_set_tone2:
					mov	ax,65157 ;65157=2345678/36
ay_set_tone3:
					mov	cl,0 ;j
ay_set_tone3_bucle:
					cmp	ax,400h
					jc		ay_set_tone4
					shr 	ax,1
					inc	cl
					jmp	short ay_set_tone3_bucle

ay_set_tone4:
					mov	ay_Tono,ax
					mov   ay_temp,cl

					mov	al,byte ptr ay_3_8912_registros+7
					mov	ah,1
					mov	cl,ay_Reg
					or		cl,cl
					jz    ay_set_tone4_cero
					shl	ah,cl
ay_set_tone4_cero:
					and	al,ah
					jnz	ay_set_tone_no0
					mov	al,byte ptr ay_Tono
					mov	ah,0a0h
					add	ah,ay_Reg
					call	write_adlib

					mov	cl,ay_temp
					and	cl,7
					mov	al,byte ptr ay_Tono+1
					and	al,3

					shl   cl,1
					shl	cl,1
					or		al,cl
					or		al,020h ;key on
					mov	ah,0b0h
					add	ah,ay_Reg
					call	write_adlib

ay_set_tone_no0:
					mov	al,byte ptr ay_3_8912_registros+7
					mov	ah,8
					mov	cl,ay_Reg
					or		cl,cl
					jz		ay_set_tone_no0_cero
					shl	ah,cl
ay_set_tone_no0_cero:
					and	al,ah
					jnz	ay_set_tone_no0_2

					mov   ax,adlib_address
					push  ax

					mov	al,byte ptr ay_Tono
					mov	ah,0a7h
					mov	adlib_address,CANAL_CEN
					call	write_adlib

					mov	cl,ay_temp
					and	cl,7
					mov	al,byte ptr ay_Tono+1
					and	al,3

					shl   cl,1
					shl	cl,1
					or		al,cl
					or		al,020h ;key on
					mov	ah,0b7h
					call	write_adlib

					pop   ax
					mov   adlib_address,ax


ay_set_tone_no0_2:
					mov	al,byte ptr ay_3_8912_registros+7
					mov	cl,ay_Reg
					or		cl,cl
					jz    ay_set_tone_no0_2_cero
					shr   al,cl
ay_set_tone_no0_2_cero:
					and	al,9

					cmp	al,8
					jz    ay_set_tone_8
					cmp	al,1
					jz    ay_set_tone_1
					cmp	al,0
					jz    ay_set_tone_0
					ret

ay_set_tone_8:
					mov	al,byte ptr ay_Tono
					mov	ah,0a0h
					add	ah,ay_Reg
					call	write_adlib

					mov	cl,ay_temp
					and	cl,7
					mov	al,byte ptr ay_Tono+1
					and	al,3

					shl   cl,1
					shl	cl,1
					or		al,cl
					or		al,020h ;key on
					mov	ah,0b0h
					add	ah,ay_Reg
					jmp	write_adlib

ay_set_tone_1:

					mov	al,byte ptr ay_Tono
					mov	adlib_address,CANAL_CEN
					mov	ah,0a7h
					call	write_adlib

					mov	cl,ay_temp
					and	cl,7
					mov	al,byte ptr ay_Tono+1
					and	al,3

					shl   cl,1
					shl	cl,1
					or		al,cl
					or		al,020h ;key on
					mov	ah,0b7h
					jmp	write_adlib

ay_set_tone_0:
					call	ay_set_tone_8
					jmp	ay_set_tone_1


refrescar_chip_ay_no:
					ret

refrescar_chip_ay:

					mov	al,bits_estado4
					test	al,00011110b  ;Mirar si esta el refresco,
					jnz  	refrescar_chip_ay_no ;que la salida este a Sblaster,
														;que este el chip presente

					test  bits_estado4,00100000b ;Decir que esta el menu activo
					jz    refrescar_chip_ay2

					test  bits_estado5,1 ;Mirar que no se este en modo pausa
												;con el menu activo
					jnz   refrescar_chip_ay_no

refrescar_chip_ay2:

					cmp	soundblaster_presente,1 ;Mirar que exista SBlaster
					jnz  	refrescar_chip_ay_no

refrescar_chip_ay_si:


					mov   refrescar_chip_bx,bx
					mov   refrescar_chip_cx,cx
					mov   refrescar_chip_dx,dx

					call	refresco_ay_silencio

					mov	al,0
					call	ay_set_tone
					mov	al,1
					call	ay_set_tone
					mov	al,2
					call	ay_set_tone

					mov   bx,refrescar_chip_bx
					mov   cx,refrescar_chip_cx
					mov   dx,refrescar_chip_dx


					ret

refresco_ay_silencio:
					mov	cx,3
					mov	bx,offset puerto_canal_a

					mov	ah,0b0h

refresco_ay:

					mov	ay_Reg,ah
					push	cx

					mov	ax,word ptr [bx]
					mov	adlib_address,ax
					inc	bx
					inc	bx

					mov	al,byte ptr ay_3_8912_registros+7
					mov	cl,ay_Reg
					sub	cl,0b0h
					or		cl,cl
					jz    refresco_ay_0
					shr   al,cl
refresco_ay_0:
					and	al,9
					cmp	al,9
					jz    refresco_ay_no

					call	read_adlib
					mov	ah,ay_Reg
					and	al,11011111b
					call	write_adlib

refresco_ay_no:

					mov	ah,ay_Reg
					inc	ah
					pop	cx
					loop	refresco_ay

					mov	al,byte ptr ay_3_8912_registros+7
					and	al,00111111b
					cmp	al,00111111b
					jz    refresco_ay_no2

					mov	adlib_address,CANAL_CEN


					mov	ah,0b7h
					call	read_adlib
					mov	ah,0b7h
					and	al,11011111b
					call	write_adlib

refresco_ay_no2:
					ret

silenciar_canales:
					;Mirar que exista Sblaster, que exista chip AY

					test	bits_estado4,00000010b
					jnz	silenciar_canales_fin
					cmp	soundblaster_presente,1
					jnz	silenciar_canales_fin

					call  refresco_ay_silencio

silenciar_canales_fin:
					ret



